Index: u-boot/cpu/mpc5xxx/usb_ohci.c
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/mpc5xxx/usb_ohci.c,v
retrieving revision 1.1
diff -p -u -r1.1 usb_ohci.c
--- u-boot/cpu/mpc5xxx/usb_ohci.c	26 Feb 2004 23:46:22 -0000	1.1
+++ u-boot/cpu/mpc5xxx/usb_ohci.c	1 Mar 2004 10:37:35 -0000
@@ -488,7 +488,7 @@ static int ep_link (ohci_t *ohci, ed_t *
 		if (ohci->ed_controltail == NULL) {
 			writel (ed, &ohci->regs->ed_controlhead);
 		} else {
-			ohci->ed_controltail->hwNextED = ohci_cpu_to_le32 (ed);
+			ohci->ed_controltail->hwNextED = (int) ohci_cpu_to_le32 (ed);
 		}
 		ed->ed_prev = ohci->ed_controltail;
 		if (!ohci->ed_controltail && !ohci->ed_rm_list[0] &&
@@ -504,7 +504,7 @@ static int ep_link (ohci_t *ohci, ed_t *
 		if (ohci->ed_bulktail == NULL) {
 			writel (ed, &ohci->regs->ed_bulkhead);
 		} else {
-			ohci->ed_bulktail->hwNextED = ohci_cpu_to_le32 (ed);
+			ohci->ed_bulktail->hwNextED = (int) ohci_cpu_to_le32 (ed);
 		}
 		ed->ed_prev = ohci->ed_bulktail;
 		if (!ohci->ed_bulktail && !ohci->ed_rm_list[0] &&
@@ -598,7 +598,7 @@ static ed_t * ep_add_ed (struct usb_devi
 		ed->hwINFO = ohci_cpu_to_le32 (OHCI_ED_SKIP); /* skip ed */
 		/* dummy td; end of td list for ed */
 		td = td_alloc (usb_dev);
-		ed->hwTailP = ohci_cpu_to_le32 (td);
+		ed->hwTailP = (int) ohci_cpu_to_le32 (td);
 		ed->hwHeadP = ed->hwTailP;
 		ed->state = ED_UNLINK;
 		ed->type = usb_pipetype (pipe);
@@ -656,12 +656,12 @@ static void td_fill (ohci_t *ohci, unsig
 		data = 0;
 
 	td->hwINFO = ohci_cpu_to_le32 (info);
-	td->hwCBP = ohci_cpu_to_le32 (data);
+	td->hwCBP = (int) ohci_cpu_to_le32 (data);
 	if (data)
-		td->hwBE = ohci_cpu_to_le32 (data + len - 1);
+		td->hwBE = (int) ohci_cpu_to_le32 (data + len - 1);
 	else
 		td->hwBE = 0;
-	td->hwNextTD = ohci_cpu_to_le32 (td_pt);
+	td->hwNextTD = (int) ohci_cpu_to_le32 (td_pt);
 	td->hwPSW [0] = ohci_cpu_to_le16 (((__u32)data & 0x0FFF) | 0xE000);
 
 	/* append to queue */
@@ -1532,10 +1532,19 @@ int usb_lowlevel_init(void)
 {
 
 	/* Set the USB Clock						     */
+#if defined (CONFIG_USB_CDMFDC5xxx)
+	*(vu_long *)MPC5XXX_CDM_48_FDC = CONFIG_USB_CDMFDC5xxx;
+#else
 	*(vu_long *)MPC5XXX_CDM_48_FDC = 0x0001bbbb;
-	*(vu_long *)MPC5XXX_GPS_PORT_CONFIG &= ~0x00800000;
+#endif
+	/* remove all USB bits first before ORing in ours */
+	*(vu_long *)MPC5XXX_GPS_PORT_CONFIG &= ~0x00807000;
 	/* Activate USB port						     */
+#if defined (CONFIG_USB_GPSCFG5xxx)
+	*(vu_long *)MPC5XXX_GPS_PORT_CONFIG |= CONFIG_USB_GPSCFG5xxx;
+#else
 	*(vu_long *)MPC5XXX_GPS_PORT_CONFIG |= 0x00001000;
+#endif
 
 	memset (&gohci, 0, sizeof (ohci_t));
 	memset (&urb_priv, 0, sizeof (urb_priv_t));
